<?php
/***************************************************************************
phpWebThins parser

version           : 2.2.3
Author            : O.J. Visser
Last modification : 09-05-2005
***************************************************************************/
function preparsecode($message, $realname, $username)
{
	global $settings, $ext;

	// This line makes all languages *theoretically* work even with the wrong charset ;).
	$message = preg_replace('~&amp;#(\d{4,5}|[4-9]\d{2,4});~', '&#$1;', $message);

	if (strstr($realname, '[') || strstr($realname, ']') || strstr($realname, '\'') || strstr($realname, '"'))
		$realname = $username;

	$codes = array('/(\/me) (.*)([\r\n]?)/i');
	$codesto = array("[me=$realname]\\2[/me]\\3");

	$message = preg_replace($codes, $codesto, $message);
	$message = str_replace("\r", '', $message);

	// Check if all quotes are closed
	$parts = preg_split ("/(\[\/quote\])/is", $message, -1, PREG_SPLIT_DELIM_CAPTURE);
	
	$level = 0;
	for ($i = 0; $i < count($parts); $i++)
	{
		if (preg_match('/\[\/quote\]/i',$parts[$i]) !=0 )
			$level--;
		preg_match_all("/(\[quote=(.+?)\])|(\[quote\])/is", $parts[$i], $regs);
		$level += count ($regs[0]);
		while ($level < 0)
		{
			$parts[$i] = '[quote]'.$parts[$i];
			$level++;
		}
	}
	$message = implode ('', $parts);
	while ($level > 0)
	{
		$message .= '[/quote]';
		$level--;
	}

	// Check if all code tags are closed
	preg_match_all("/(\[code\])/", $message, $regs);
	$codeopen = count($regs[0]);
	preg_match_all("/(\[\/code\])/", $message, $regs);
	$codeclose = count($regs[0]);

	if ($codeopen > $codeclose)
	{
		$toclose = $codeopen - $codeclose;
		for ($i = 0 ; $i < $toclose ; $i++)
			$message .= "[/code]";
	}
	elseif ($codeclose > $codeopen)
	{
		$toopen = $codeclose - $codeopen;
		for ($i = 0 ; $i < $toopen ; $i++)
			$message = "[code]$message";
	}

	// now that we've fixed all the code tags, let's fix the IMG and URL tags
	$parts = split('\[\/?code\]', " $message");

	for ($i = 0 ;$i < count($parts) ;$i++)
	{
		if ($i % 2 == 0)
		{
			$parts[$i] = fixTags($parts[$i]);
			if ($i > 0)
				$parts[$i] = '[/code]' . $parts[$i];
		}
		else 
			$parts[$i] = '[code]' . $parts[$i];
	}
	$message = substr(implode('', $parts), 1);	
	return $message;
}

function fixTags($message)
{
	$fixArray = array
	(
		array('tag' => 'img', 'protocol' => 'http', 'embeddedUrl' => false, 'hasEqualSign' => false),
		array('tag' => 'url', 'protocol' => 'http', 'embeddedUrl' => true, 'hasEqualSign' => false),
		array('tag' => 'url', 'protocol' => 'http', 'embeddedUrl' => true, 'hasEqualSign' => true),
		array('tag' => 'iurl', 'protocol' => 'http', 'embeddedUrl' => true, 'hasEqualSign' => false),
		array('tag' => 'iurl', 'protocol' => 'http', 'embeddedUrl' => true, 'hasEqualSign' => true),
		array('tag' => 'ftp', 'protocol' => 'ftp', 'embeddedUrl' => true, 'hasEqualSign' => false),
		array('tag' => 'ftp', 'protocol' => 'ftp', 'embeddedUrl' => true, 'hasEqualSign' => true),
		array('tag' => 'flash', 'protocol' => 'http', 'embeddedUrl' => false, 'hasEqualSign' => true),
		array('tag' => 'irc', 'protocol' => 'irc', 'embeddedUrl' => false, 'hasEqualSign' => false)
	);

	while (preg_match("/\[sp\](.+?)\[\/sp\]/i", $message, $matches))
	{
		$searchfor = $matches[1];
		$replace = $searchfor;
		$replace = trim($replace);	// remove all leading and trailing whitespaces
		$replacestr="";	
		if ($replace>0)
    {
      for ($i=0;$i<$replace;$i++) $replacestr=$replacestr."&nbsp;";
    }	
		$message = str_replace(array("[sp]{$searchfor}[/sp]", "[SP]{$searchfor}[/SP]"), array("{sp}$replacestr{/sp}", "{SP}$replacestr{/SP}"), $message);
	}
	$message = str_replace(array('{sp}', '{/sp}', '{SP}', '{/SP}'), array('[sp]', '[/sp]', '[SP]', '[/SP]'), $message);
	$message = str_replace(array('[PHP]', '[/PHP]'),array('[php]','[/php]'),  $message);

	foreach ($fixArray as $param)
		$message = fixTag($message, $param['tag'], $param['protocol'], $param['embeddedUrl'], $param['hasEqualSign']);

	return $message;
}

function fixTag($message, $myTag, $protocol, $embeddedUrl = false, $hasEqualSign = false)
{
	$isEqual = ($hasEqualSign ? '(=(.+?))' : '(())');
	while (preg_match("/\[($myTag)$isEqual\](.+?)\[\/($myTag)\]/si", $message, $matches))
	{
		$leftTag = $matches[1];
		$equalTo = $matches[3];
		$searchfor = $matches[4];
		$rightTag = $matches[5];
		$replace = ($hasEqualSign && $embeddedUrl ? $equalTo : $searchfor);
		$replace = trim($replace);	// remove all leading and trailing whitespaces
		if (!stristr($replace, "$protocol://"))
		{

			if ($protocol != 'http' || !stristr($replace,'https://'))
				$replace = "$protocol://$replace";
			else
				$replace = stristr($replace, 'https://');
		}
		else
			$replace = stristr($replace, "$protocol://");
		if ($hasEqualSign && $embeddedUrl)
			$message = str_replace(
				"[$leftTag=$equalTo]{$searchfor}[/$rightTag]",
				"\{$myTag=$replace]$searchfor\{/$myTag\}", $message);
		elseif ($hasEqualSign && !$embeddedUrl)
			$message = str_replace(
				"[$leftTag=$equalTo]{$searchfor}[/$rightTag]",
				"\{$myTag=$equalTo]$replace\{/$myTag\}", $message);
		elseif ($embeddedUrl)
			$message = str_replace(
				"[$leftTag]{$searchfor}[/$rightTag]",
				"\{$myTag=$replace]$searchfor\{/$myTag\}", $message);
		else
		{
			$message = str_replace(
				"[$leftTag]{$searchfor}[/$rightTag]",
				"\{$myTag\}$replace\[/$myTag\}", $message);
		}		
	}
  if ($myTag=="img")
  {
	 while (preg_match("/\[($myTag)\ (.+?)\](.+?)\[\/($myTag)\]/si", $message, $matches))
	 {
		$leftTag = $matches[1];
		$equalTo = $matches[2];
		$searchfor = $matches[3];
		$rightTag = $matches[4];
		$replace = ($hasEqualSign && $embeddedUrl ? $equalTo : $searchfor);
		$replace = trim($replace);	// remove all leading and trailing whitespaces
		if (!stristr($replace, "$protocol://"))
		{

			if ($protocol != 'http' || !stristr($replace,'https://'))
				$replace = "$protocol://$replace";
			else
				$replace = stristr($replace, 'https://');
		}
		else
			$replace = stristr($replace, "$protocol://");
		if ($hasEqualSign && $embeddedUrl)
			$message = str_replace(
				"[$leftTag=$equalTo]{$searchfor}[/$rightTag]",
				"\{$myTag=$replace]$searchfor\{/$myTag\}", $message);
		elseif ($hasEqualSign && !$embeddedUrl)
			$message = str_replace(
				"[$leftTag=$equalTo]{$searchfor}[/$rightTag]",
				"\{$myTag=$equalTo]$replace\{/$myTag\}", $message);
		elseif ($embeddedUrl)
			$message = str_replace(
				"[$leftTag]{$searchfor}[/$rightTag]",
				"\{$myTag=$replace]$searchfor\{/$myTag\}", $message);
		else
		{
			$message = str_replace(
				"[$leftTag $equalTo]{$searchfor}[/$rightTag]",
				"\{$myTag $equalTo]$replace\{/$myTag\}", $message);
		}		
	 }
	}
	if ($embeddedUrl || $hasEqualSign)
		$message = str_replace(
			array("\{$myTag=", "\{/$myTag\}"),
			array("[$myTag=", "[/$myTag]"), $message);
	else
	{
		$message = str_replace(
			array("\{$myTag\}", "\[/$myTag\}"),
			array("[$myTag]", "[/$myTag]"), $message);
		$message = str_replace(
			array("\{$myTag", "\{/$myTag\}"),
			array("[$myTag", "[/$myTag]"), $message);
	}
	return $message;
}

function doUBBC($message,$enableSmilies = 1)
{
	global $settings, $text, $txt;

// $message = stripslashes($message); // Maybe you'll have to uncomment this
	$parts = split('\[\/?php\]', ' ' . $message);

	for ($i = 0; $i < count($parts); $i++)
	{
	  if ($i % 2 == 0)
	  {
	    $parts1 = split('\[\/?code\]', ' ' . $parts[$i]);

	    for ($i1 = 0; $i1 < count($parts1); $i1++)
	    {
		   if ($i1 % 2 == 0)
		   {
		     $parts1[$i1] = str_replace(array('$', '[[', ']]'), array('&#36;', '{<{', '}>}'), $parts1[$i1]);
             //Bad word replacements, if activated.
             $parts1[$i1]=badword_filter($parts1[$i1]);
             $parts1[$i1]=str_replace('<', '&lt;', str_replace('>', '&gt;', $parts1[$i1]));
			 $parts1[$i1] = doparsecodesmilies($parts1[$i1], $enableSmilies);
    	
		   }
		   elseif ($i1 <= count($parts1) - 1)
		   {
             $parts1[$i1]=htmlentities($parts1[$i1]);
             $parts1[$i1]=str_replace('<', '&lt;', str_replace('>', '&gt;', $parts1[$i1]));
			 $parts1[$i1] = "<font size=\"1\"><b>Code:</b></font><table border=\"0\" cellspacing=\"1\" cellpadding=\"2\" width=\"100%\"><tr><td class=\"code\"><font face=\"Courier new\">{$parts1[$i1]}</td></tr></table>";
		   }
	    }
	    $parts[$i] = substr(implode('', $parts1), 1);
	  }
	  elseif ($i <= count($parts) - 1)
			$parts[$i]=phphighlight($parts[$i]);
    }
	$message = substr(implode('', $parts), 1);
	$message = str_replace(
		array('{<{', '}>}', '  ', "\t", "\n\r", "\r", "\n"),
		array('[', ']', '&nbsp; ', '&nbsp; &nbsp; ', '<br />', '<br />', '<br />'), $message);


	return $message;

}

function badword_filter($text)
{
 global $cfg;
 if (!empty($cfg["forum"]["bwords"]) and !empty($cfg["forum"]["rwords"]))
 {
    $fromcache=explode(",",$cfg["forum"]["bwords"]);
    $tocache=explode(",",$cfg["forum"]["rwords"]);
    if ($cfg["forum"]["bwfilter"] and (count($fromcache)==count($tocache)))
    {
        for ($i=0;$i<count($fromcache);$i++)
        {
            $text=eregi_replace(" ".$fromcache[$i]." "," ".$tocache[$i]." ",$text);
        }
    }
    elseif (count($fromcache)<>count($tocache))
        echo "error, number of bad words is different from the number of replace words";
    return $text;
 }
 else return $text;
}

function doparsecodesmilies($message,$enableSmilies = 1)
{
	global $codefromcache, $codetocache, $smileyfromcache, $smileytocache, $text, $scripturl, $imagesdir,$txt;

	if (gettype($codefromcache) != 'array' || gettype($smileyfromcache) != 'array')
	{
		$codefromcache = array(
			'/([a-z0-9_-][a-z0-9\._-]*@[a-z0-9_-]+(\.[a-z0-9_-]+)+)/is',
			'/\[irc\](.+?)\[\/irc\]/is',
			'/\[rurl\](.+?)\[\/rurl\]/is',
			'/\[rurl=(.+?)\](.+?)\[\/rurl\]/is',
			'/\[url\](.+?)\[\/url\]/is',
			'/\[url=(.+?)\](.+?)\[\/url\]/is',
			'/\[iurl\](.+?)\[\/iurl\]/is',
			'/\[iurl=(.+?)\](.+?)\[\/iurl\]/is',
			'/\[p\](.+?)\[\/p\]/is',
			'/\[b\](.+?)\[\/b\]/is',
			'/\[i\](.+?)\[\/i\]/is',
			'/\[u\](.+?)\[\/u\]/is',
			'/\[s\](.+?)\[\/s\]/is',
			'/\[move\](.+?)\[\/move\]/is',
			'/\n?\[quote=(.+?)\]\n*/ei',
			'/\[\/quote\]/i',
			'/\n?\[quote\]\n*/i',
			'/\[me=([^\]]+)\](.+?)\[\/me\]/is',
			'/\[img=(.+?)\](.+?)\[\/img\]/i',
			'/\[img\](.+?)\[\/img\]/i',
			'/\[img (.+?)\](.+?)\[\/img\]/i',
			'/\[rimg=(.+?)\](.+?)\[\/rimg\]/i',
			'/\[rimg\](.+?)\[\/rimg\]/i',
			'/\[rimg (.+?)\](.+?)\[\/rimg\]/i',
			'/\[color=([\w#]+)\](.*?)\[\/color\]/is',
			'/\[black\](.+?)\[\/black\]/is',
			'/\[white\](.+?)\[\/white\]/is',
			'/\[red\](.+?)\[\/red\]/is',
			'/\[green\](.+?)\[\/green\]/is',
			'/\[blue\](.+?)\[\/blue\]/is',
			'/\[font=(.+?)\](.+?)\[\/font\]/is',
			'/\[size=(.+?)\](.+?)\[\/size\]/is',
			'/\[pre\](.+?)\[\/pre\]/is',
			'/\[left\](.+?)\[\/left\]/is',
			'/\[right\](.+?)\[\/right\]/is',
			'/\[center\](.+?)\[\/center\]/is',
			'/\[sub\](.+?)\[\/sub\]/is',
			'/\[sup\](.+?)\[\/sup\]/is',
			'/\[tt\s*(.*?)\s*\](.+?)\[\/tt\]/is',
			'/\[th\s*(.*?)\s*\](.+?)\[\/th\]/is',
			'/\[table\s*(.*?)\s*\]\s*(.+?)\s*\[\/table\]\s?/is',
			'/\s*\[tr\s*(.*?)\s*\]\s*(.*?)\s*\[\/tr\]\s*/is',
			'/\s*\[td\s*(.*?)\s*\]\s*(.*?)\s*\[\/td\]\s*/is',
			'/\[ftp\](.+?)\[\/ftp\]/is',
			'/\[ftp=(.+?)\](.+?)\[\/ftp\]/is',
			'/\[glow=(.+?),(.+?),(.+?)\](.+?)\[\/glow\]/eis',
			'/\[shadow=(.+?),(.+?)\](.+?)\[\/shadow\]/eis',
			'/\[email\](.+?)\[\/email\]/is',
			'/\[hr\]/i',
			'/\[flash=(\S+?),(\S+?)\](\S+?)\[\/flash\]/is',
			'/\[list\]/',
			'/\[\/list\]/',
			'/(<\/?table>|<\/?tr>|<\/td>)<br \/>/',
			'/\[email=(.+?)\](.+?)\[\/email\]/is',
      '/\[sp\](.+?)\[\/sp\]/i');

		$codetocache = array(
      '<a href=mailto:\\1>\\1</a>',
			'<a href="\\1" target="_blank">\\1</a>',
			'<a href="\\1">\\1</a>',
			'<a href="\1">\\2</a>',
			'<a href="\\1" target="_blank">\\1</a>',
			'<a href="\\1" target="_blank">\\2</a>',
			'<a href="\\1">\\1</a>',
			'<a href="\\1">\\2</a>',
			'<p>\\1</p>',
			'<b>\\1</b>',
			'<i>\\1</i>',
			'<u>\\1</u>',
			'<s>\\1</s>',
			'<marquee>\\1</marquee>',
			"'<br><table width=\"100%\" class=\"quote\"><tr><td>\\1 :<br><br>'",
			"</td></tr></table>",
			"<br><table width=\"100%\" class=\"quote\"><tr><td>",
			"<font class=\"meaction\">* \\1 \\2</font>",
			'<img src="\\2" alt="\\2" >',
			'<img src="\\1" >',
			'<img src="\\2" \\1 >',
			'<img src="\\2" alt="\\2" >',
			'<img src="\\1" >',
			'<img src="\\2" \\1 >',
			'<font color="\\1">\\2</font>',
			'<font color="#000000">\\1</font>',
			'<font color="#FFFFFF">\\1</font>',
			'<font color="#FF0000">\\1</font>',
			'<font color="#00FF00">\\1</font>',
			'<font color="#0000FF">\\1</font>',
			'<font face="\\1">\\2</font>',
			'<font size="\\1">\\2</font>',
			'<pre>\\1</pre>',
			'<div align="left">\\1</div>',
			'<div align="right">\\1</div>',
			'<div align="center">\\1</div>',
			'<sub>\\1</sub>',
			'<sup>\\1</sup>',
			'<tt \\1>\\2</tt>',
			'<th \\1>\\2</th>',
			'<table \\1>\\2</table>',
			'<tr \\1>\\2</tr>',
			'<td \\1>\\2</td>',
			'<a href="\\1" target="_blank">\\1</a>',
			'<a href="\\1" target="_blank">\\2</a>',
			"'<table style=\"border 0px;\"><tr><td style=\"filter:Glow(color=\\1, strength=' . ('\\2' < 255 ? '\\2' : '255') . ');\">' . \"\\4\" . '</td></tr></table>'",
			"'<table style=\"border 0px;\"><tr><td style=\"filter:Shadow(color=\\1, direction=' . ('\\2' == 'left' ? '225' : ('\\2' == 'right' ? '135' : ('\\2' == 'top' ? '0' : ('\\2' == 'bottom' ? '180' : '\\2')))) . ');\">' . \"\\3\" . '</td></tr></table>'",
//			'<a href="mailto:\\1">\\1</a>',
			'\\1',
			'<hr />',
			'<object classid="clsid:D27CDB6E-AE6D-11cf-96B8-444553540000" width="\\1" height="\\2"><param name="movie" value="\\3" /><param name="AllowScriptAccess" value="never" /><param name="play" value="true" /><param name="loop" value="true" /><param name="quality" value="high" /><embed src="\\3" AllowScriptAccess="never" width="\\1" height="\\2" play="true" loop="true" quality="high"></embed></object>',
			'<ul>',
			'</ul>',
			'\\1',
			'<a href="mailto:\\1">\\2</a>',
			'\\1');

		// Instead we use:
		$smiliesfrom = array('::)', ']:(', '>:(', '&gt;:(', ']:D', '>:D', ':)',':-)', ';)', ';-)', ':D', ';D', ':(', ':-(', ':o', '8)', ':P', '???', ':-[', ':-X', ':-*', ":'(",':&#039;(',':-\\','^-^',':z',':b',':r',':*(',':p');

		$smiliesto = array('rolleyes', 'angry', 'angry', 'angry', 'evil', 'evil', 'smiley', 'smiley', 'wink', 'wink', 'cheesy', 'grin', 'sad', 'sad', 'shocked', 'cool', 'tongue', 'huh', 'embarassed', 'lipsrsealed', 'kiss', 'cry', 'cry', 'undecided', 'azn', 'sleep', 'beer','puke','offtopic1','puke'); // You'll get the idea

		// This smiley regex makes sure it doesn't parse smilies within code tags (so [url=mailto:David@bla.com] doesn't parse the :D smiley)
		for ($i = 0; $i < count($smiliesfrom); $i++)
		{
			$smileyfromcache[] = '/([>\s\n\r]|(?:(?:(?:>[^<]*)|(?:^[^<]*))[\s\n\r]))(' . str_replace('|', '\|', quotemeta(str_replace('/', '\/', $smiliesfrom[$i]))) . ')/s';
			$smileytocache[] = "\\1<img src=\"var/smileys/$smiliesto[$i].gif\" alt=\"\" border=\"0\" />";
		}
	}

	$message = parsesmilies($message);

	$message = parsecode($message);

	// List items
	$itemcode = array(
		'*' => '',
		'@' => ' type="disc"',
		'+' => ' type="square"',
		'x' => ' type="square"',
		'#' => ' type="square"',
		'o' => ' type="circle"',
		'0' => ' type="circle"');
	$message = preg_replace("!\\[([*@+x#o0])\\]!Uie", '\'<li\'.$itemcode[\'\\1\'].\'>\'', $message);

//	echo $message;
  if ( strstr($message, '&lt;'))
  {
		// b, u, i, s, pre... basic tags.
		$closable_tags = array('b', 'u', 'i', 's', 'pre', 'blockquote');
		foreach ($closable_tags as $tag)
		{
			$opens = substr_count($message, '&lt;' . $tag . '&gt;');
			$closes = substr_count($message, '&lt;/' . $tag . '&gt;');
			$message = str_replace('&lt;' . $tag . '&gt;', '<' . $tag . '>', $message);
			$message = preg_replace('/&lt;\/' . $tag . '&gt;/', '</' . $tag . '>', $message, $opens);
			if ($closes < $opens)
				$message .= str_repeat('</' . $tag . '>', $opens - $closes);
		}
	}
	return $message;

}

function parsecode($message)
{
	global $codefromcache, $codetocache, $modSettings;

	if (!strstr($message, '[') && !strstr($message, '://') && !strstr($message, '@') && !strstr($message, '/me'))
		return $message;

	if (gettype($codefromcache) != 'array')
		return $message;
  if (preg_match_all('/<a href=mailto:(.*)>(.*)<\/a>/',$message,$match, PREG_PATTERN_ORDER))
  {
		for ($i = 0; $i < count($match[0]); $i++)
		{
      $emailnew[$i]="<script language=\"JavaScript\">eval(unescape('".hex_encode("document.write('{$match[0][$i]}')")."'))</script>";
    }
		$message = str_replace($match[0], $emailnew, $message);
  }
	$maxwidth = 600;
	$maxheight = 800;
  $image_tag=array("img","rimg");
	foreach ($image_tag as $mytag)
	{
	while (preg_match("/\[$mytag\](.+?)\[\/$mytag\]/si", $message, $tmatches))
	{
    $searchfor=$tmatches[1];
      $test=explode(" ",$searchfor);
      $searchfor1="";
			  for ($t = 0; $t<count($test); $t++)
			  {
   		        if ((!stristr($test[$t],";")) 
				    and (!stristr($test[$t],")"))
				    and (!stristr($test[$t],"(")))
			    {
                  if (stristr($test[$t],"alt")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"align")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"border")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"height")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"hspace")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"longdesc")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"vspace")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],"width")) $searchfor1 .=" ".$test[$t];
                  if (stristr($test[$t],".gif") or
                      stristr($test[$t],".jpg") or
                      stristr($test[$t],".png") or
                      stristr($test[$t],".tif") or
                      stristr($test[$t],".jpeg"))
                  $searchfor1 .=$test[$t];
				}    
			  }
			$imagesize = @getimagesize($searchfor1);
			$width = $imagesize[0];
			$height = $imagesize[1];
			if ($width > $maxwidth || $height > $maxheight)
			{
				if ($width > $maxwidth && $maxwidth != '0')
				{
					$height = floor($maxwidth / $width * $height);
					$width = $maxwidth;
					if ($height > $maxheight && $maxheight != '0')
					{
						$width = floor($maxheight / $height * $width);
						$height = $maxheight;
					}
				}
				else
				{
					if ($height > $maxheight && $maxheight != '0')
					{
						$width = floor($maxheight / $height * $width);
						$height = $maxheight;
					}
				}
			}
			$tempstr="border=\"0\" alt=\"\"";
			$repl="";
			if ($width>0) $repl="width=\"$width\" ";
			if ($height>0) $repl.="height=\"$height\" ";
      $repl.=trim($tempstr);
			$message = str_replace(
				"[$mytag]{$searchfor}[/$mytag]",
				"\{$mytag $repl]$searchfor1\{/$mytag\}", $message);
	}
	 while (preg_match("/\[$mytag\ (.+?)\](.+?)\[\/$mytag\]/si", $message, $tmatches))
	{
      $searchfor=$tmatches[2];
      echo "<pre>";
      print_r($tmatches);
      echo "</pre>";
	  $imagesize = @getimagesize($searchfor);
	  $width = $imagesize[0];
	  $height = $imagesize[1];
       $repl=$tmatches[1];
			$tempmatches=array();
			  $tempstr="";
			  $tempmatches=explode(" ",$repl);
			  for ($t = 0; $t<count($tempmatches); $t++)
			  {
           if (!strstr($tempmatches[$t],"=\"") and !strstr($tempmatches[$t],"='"))
           {
            $tempmatches[$t]=str_replace("=","=\"",$tempmatches[$t]);
           }
           if (strlen($tempmatches[$t])<>0 and substr($tempmatches[$t],strlen($tempmatches[$t])-1)<>"\"" and substr($tempmatches[$t],strlen($tempmatches[$t])-1)<>"'")
           {

               $tempmatches[$t].="\"";
           }
          if (strstr($tempmatches[$t],"width=")) $width=substr($tempmatches[$t],7,strlen($tempmatches[$t])-8);
          elseif (strstr($tempmatches[$t],"height=")) $height=substr($tempmatches[$t],8,strlen($tempmatches[$t])-9);
          else
          {
           if ($tempstr<>"") $tempstr=rtrim($tempstr)." ".$tempmatches[$t];
                else  $tempstr=$tempmatches[$t];
          }
        }
			  if (!stristr($tempstr,"border"))
			  {
          if ($tempstr<>"") $tempstr=rtrim($tempstr)." border=\"0\"";
               else  $tempstr=" border=\"0\"";
			  }
			  if (!stristr($tempstr,"alt"))
			  {
          if ($tempstr<>"") $tempstr=rtrim($tempstr)." alt=\"\"";
               else  $tempstr=" alt=\"\"";
			  }
			  if ($width<>$imagesize[0] and $imagesize[0]<>0)
			  {
			     $height = floor($width / $imagesize[0] * $height);
			  }
			  else
        {
         if ($height<>$imagesize[1]and $imagesize[1]<>0)
			   {
			     $width = floor($height / $imagesize[1] * $width);
			   }
        }
			if ($width > $maxwidth || $height > $maxheight)
			{
				if ($width > $maxwidth && $maxwidth != '0')
				{
					$height = floor($maxwidth / $width * $height);
					$width = $maxwidth;
					if ($height > $maxheight && $maxheight != '0')
					{
						$width = floor($maxheight / $height * $width);
						$height = $maxheight;
					}
				}
				else
				{
					if ($height > $maxheight && $maxheight != '0')
					{
						$width = floor($maxheight / $height * $width);
						$height = $maxheight;
					}
				}
			}
			if ($tempstr=="") $tempstr="border=\"0\" alt=\"\"";
			$repl1="";
			if ($width>0) $repl1="width=\"$width\" ";
			if ($height>0) $repl1.="height=\"$height\" ";
      $repl1.=trim($tempstr);
			$message = str_replace(
				"[$mytag $repl]{$searchfor}[/$mytag]",
				"\{$mytag $repl1]$searchfor\{/$mytag\}", $message);
	 }
		$message = str_replace(
			array("\{$mytag", "\{/$mytag\}"),
			array("[$mytag", "[/$mytag]"), $message);
  }
	$message = preg_replace($codefromcache, $codetocache, $message);
	return $message;
}

function parsesmilies($message)
{
	global $smileyfromcache, $smileytocache;

	$oldmessage = '';
	while ($oldmessage != $message)
	{
		$oldmessage = $message;
		$message = preg_replace($smileyfromcache, $smileytocache, $message);
	}
	return $message;
}


function phphighlight($code)
{
  $version=phpversion();
	if (floor($version) < 4)
		$buffer=$code;
	else
	{
	
		$code = str_replace(array('&gt;', '&lt;', '&#36;', '&quot;'), array('>', '<', '$', '"'), $code);

		if (!strstr($code, '<?'))
		{
			$code="<?php\n".trim($code)."\n?" .'>';
			$addedtags = 1;
		}
		ob_start();
		$oldlevel = error_reporting(0);
    $buffer=highlight_string($code);
		error_reporting($oldlevel);
		$buffer = ob_get_contents();
		ob_end_clean();
		$buffer = str_replace('&quot;', '"', $buffer);
		$buffer = str_replace('<font color="','<span style="color: ',$buffer);
		$buffer = str_replace('</font>','</span>',$buffer);
	}
	return $buffer;
}

function parse_tags3( &$text, &$err )
{
  $text=preparsecode($text, $_SESSION["wt"]["name"], $_SESSION["wt"]["name"]);
  $text=DoUBBC($text, 1);
}
?>
