<?php
/*****************************************************************************
* tab_users.php                                                              *
******************************************************************************
* created:      2004-11-02                                                   *
* Author:       Yuriy Bortnik                                                *
* Description:  Database table definition file. This file is used to upgrade *
*               the WebThingsUA database. Works for version 0.0.3 and higher *
******************************************************************************/
$table_create[$prefix."_users"]="CREATE TABLE `".$prefix."_users` (
                                `uid` int(10) unsigned NOT NULL auto_increment,
                                `name` varchar(20) NOT NULL default '',
                                `password` varchar(32) NOT NULL default '',
                                `class` enum('normal','admin') NOT NULL default 'normal',
                                `realname` varchar(40) default NULL,
                                `email` varchar(50) NOT NULL default '',
                                `url` varchar(127) default NULL,
                                `receivenews` enum('Y','N') NOT NULL default 'N',
                                `receiverel` enum('Y','N') NOT NULL default 'N',
                                `country` varchar(30) NOT NULL default '',
                                `city` varchar(30) default NULL,
                                `state` varchar(4) default NULL,
                                `icq` varchar(12) default NULL,
                                `aim` varchar(12) default NULL,
                                `sex` enum('Male','Female') default NULL,
                                `session` varchar(32) NOT NULL default '',
                                `active` enum('Y','N') NOT NULL default 'N',
                                `comments` mediumtext,
                                `newsposted` int(10) NOT NULL default '0',
                                `commentsposted` int(10) unsigned NOT NULL default '0',
                                `faqposted` int(10) unsigned NOT NULL default '0',
                                `topicsposted` int(10) unsigned NOT NULL default '0',
                                `dateregistered` datetime NOT NULL default '0000-00-00 00:00:00',
                                `dateactivated` datetime NOT NULL default '0000-00-00 00:00:00',
                                `lastvisit` datetime NOT NULL default '0000-00-00 00:00:00',
                                `logins` int(10) unsigned NOT NULL default '0',
                                `newemail` varchar(50) default NULL,
                                `newemailsess` varchar(32) default NULL,
                                `avatar` varchar(20) default NULL,
                                `lang` varchar(4) NOT NULL default '',
                                `theme` varchar(20) NOT NULL default '',
                                `signature` text NOT NULL,
                                `banned` enum('N','Y') NOT NULL default 'N',
                                `msn` varchar(50) default NULL,
                                `showemail` enum('N','Y') NOT NULL default 'N',
                                PRIMARY KEY  (`uid`),
                                UNIQUE KEY `name` (`name`),
                                KEY `listInd` (`country`,`name`)
                                ) TYPE=MyISAM;";

$table_index[$prefix."_users"][]="KEY `listInd` (`country`,`name`)";
$table_index[$prefix."_users"][]="UNIQUE KEY `email` (`email`)";
$table_index[$prefix."_users"][]="UNIQUE KEY `name` (`name`)";
$table_index[$prefix."_users"][]="PRIMARY KEY (`uid`)";

$table[$prefix."_users"]["uid"]["field"]="uid";
$table[$prefix."_users"]["uid"]["type"]="int(10) unsigned";
$table[$prefix."_users"]["uid"]["default"]="";
$table[$prefix."_users"]["uid"]["null"]="";
$table[$prefix."_users"]["uid"]["Extra"]="auto_increment";

$table[$prefix."_users"]["name"]["field"]="name";
$table[$prefix."_users"]["name"]["type"]="varchar(20)";
$table[$prefix."_users"]["name"]["default"]="";
$table[$prefix."_users"]["name"]["null"]="";
$table[$prefix."_users"]["name"]["Extra"]="";

$table[$prefix."_users"]["realname"]["field"]="realname";
$table[$prefix."_users"]["realname"]["type"]="varchar(40)";
$table[$prefix."_users"]["realname"]["default"]="";
$table[$prefix."_users"]["realname"]["null"]="YES";
$table[$prefix."_users"]["realname"]["Extra"]="";

$table[$prefix."_users"]["password"]["field"]="password";
$table[$prefix."_users"]["password"]["type"]="varchar(32)";
$table[$prefix."_users"]["password"]["default"]="";
$table[$prefix."_users"]["password"]["null"]="";
$table[$prefix."_users"]["password"]["Extra"]="";

$table[$prefix."_users"]["class"]["field"]="class";
$table[$prefix."_users"]["class"]["type"]="enum('normal','admin')";
$table[$prefix."_users"]["class"]["default"]="normal";
$table[$prefix."_users"]["class"]["null"]="";
$table[$prefix."_users"]["class"]["Extra"]="";

$table[$prefix."_users"]["email"]["field"]="email";
$table[$prefix."_users"]["email"]["type"]="varchar(50)";
$table[$prefix."_users"]["email"]["default"]="";
$table[$prefix."_users"]["email"]["null"]="";
$table[$prefix."_users"]["email"]["Extra"]="";

$table[$prefix."_users"]["url"]["field"]="url";
$table[$prefix."_users"]["url"]["type"]="varchar(127)";
$table[$prefix."_users"]["url"]["default"]="";
$table[$prefix."_users"]["url"]["null"]="YES";
$table[$prefix."_users"]["url"]["Extra"]="";

$table[$prefix."_users"]["receivenews"]["field"]="receivenews";
$table[$prefix."_users"]["receivenews"]["type"]="enum('Y','N')";
$table[$prefix."_users"]["receivenews"]["default"]="N";
$table[$prefix."_users"]["receivenews"]["null"]="";
$table[$prefix."_users"]["receivenews"]["Extra"]="";

$table[$prefix."_users"]["receiverel"]["field"]="receiverel";
$table[$prefix."_users"]["receiverel"]["type"]="enum('Y','N')";
$table[$prefix."_users"]["receiverel"]["default"]="N";
$table[$prefix."_users"]["receiverel"]["null"]="";
$table[$prefix."_users"]["receiverel"]["Extra"]="";

$table[$prefix."_users"]["country"]["field"]="country";
$table[$prefix."_users"]["country"]["type"]="varchar(30)";
$table[$prefix."_users"]["country"]["default"]="";
$table[$prefix."_users"]["country"]["null"]="";
$table[$prefix."_users"]["country"]["Extra"]="";

$table[$prefix."_users"]["city"]["field"]="city";
$table[$prefix."_users"]["city"]["type"]="varchar(30)";
$table[$prefix."_users"]["city"]["default"]="";
$table[$prefix."_users"]["city"]["null"]="YES";
$table[$prefix."_users"]["city"]["Extra"]="";

$table[$prefix."_users"]["state"]["field"]="state";
$table[$prefix."_users"]["state"]["type"]="varchar(4)";
$table[$prefix."_users"]["state"]["default"]="";
$table[$prefix."_users"]["state"]["null"]="YES";
$table[$prefix."_users"]["state"]["Extra"]="";

$table[$prefix."_users"]["icq"]["field"]="icq";
$table[$prefix."_users"]["icq"]["type"]="varchar(12)";
$table[$prefix."_users"]["icq"]["default"]="";
$table[$prefix."_users"]["icq"]["null"]="YES";
$table[$prefix."_users"]["icq"]["Extra"]="";

$table[$prefix."_users"]["aim"]["field"]="aim";
$table[$prefix."_users"]["aim"]["type"]="varchar(12)";
$table[$prefix."_users"]["aim"]["default"]="";
$table[$prefix."_users"]["aim"]["null"]="YES";
$table[$prefix."_users"]["aim"]["Extra"]="";

$table[$prefix."_users"]["msn"]["field"]="msn";
$table[$prefix."_users"]["msn"]["type"]="varchar(50)";
$table[$prefix."_users"]["msn"]["default"]="";
$table[$prefix."_users"]["msn"]["null"]="YES";
$table[$prefix."_users"]["msn"]["Extra"]="";

$table[$prefix."_users"]["sex"]["field"]="sex";
$table[$prefix."_users"]["sex"]["type"]="enum('Male','Female')";
$table[$prefix."_users"]["sex"]["default"]="";
$table[$prefix."_users"]["sex"]["null"]="YES";
$table[$prefix."_users"]["sex"]["Extra"]="";

$table[$prefix."_users"]["session"]["field"]="session";
$table[$prefix."_users"]["session"]["type"]="varchar(32)";
$table[$prefix."_users"]["session"]["default"]="";
$table[$prefix."_users"]["session"]["null"]="";
$table[$prefix."_users"]["session"]["Extra"]="";

$table[$prefix."_users"]["active"]["field"]="active";
$table[$prefix."_users"]["active"]["type"]="enum('Y','N')";
$table[$prefix."_users"]["active"]["default"]="N";
$table[$prefix."_users"]["active"]["null"]="";
$table[$prefix."_users"]["active"]["Extra"]="";

$table[$prefix."_users"]["comments"]["field"]="comments";
$table[$prefix."_users"]["comments"]["type"]="mediumtext";
$table[$prefix."_users"]["comments"]["default"]="";
$table[$prefix."_users"]["comments"]["null"]="YES";
$table[$prefix."_users"]["comments"]["Extra"]="";

$table[$prefix."_users"]["newsposted"]["field"]="newsposted";
$table[$prefix."_users"]["newsposted"]["type"]="int(10)";
$table[$prefix."_users"]["newsposted"]["default"]="0";
$table[$prefix."_users"]["newsposted"]["null"]="";
$table[$prefix."_users"]["newsposted"]["Extra"]="";

//`commentsposted` int(10) unsigned NOT NULL default '0'
$table[$prefix."_users"]["commentsposted"]["field"]="commentsposted";
$table[$prefix."_users"]["commentsposted"]["type"]="int(10) unsigned";
$table[$prefix."_users"]["commentsposted"]["default"]="0";
$table[$prefix."_users"]["commentsposted"]["null"]="";
$table[$prefix."_users"]["commentsposted"]["Extra"]="";

//`faqposted` int(10) unsigned NOT NULL default '0'
$table[$prefix."_users"]["faqposted"]["field"]="faqposted";
$table[$prefix."_users"]["faqposted"]["type"]="int(10) unsigned";
$table[$prefix."_users"]["faqposted"]["default"]="0";
$table[$prefix."_users"]["faqposted"]["null"]="";
$table[$prefix."_users"]["faqposted"]["Extra"]="";

//`topicsposted` int(10) unsigned NOT NULL default '0'
$table[$prefix."_users"]["topicsposted"]["field"]="topicsposted";
$table[$prefix."_users"]["topicsposted"]["type"]="int(10) unsigned";
$table[$prefix."_users"]["topicsposted"]["default"]="0";
$table[$prefix."_users"]["topicsposted"]["null"]="";
$table[$prefix."_users"]["topicsposted"]["Extra"]="";

//`dateregistered` datetime NOT NULL default '0000-00-00 00:00:00',"
$table[$prefix."_users"]["dateregistered"]["field"]="dateregistered";
$table[$prefix."_users"]["dateregistered"]["type"]="datetime";
$table[$prefix."_users"]["dateregistered"]["default"]="0000-00-00 00:00:00";
$table[$prefix."_users"]["dateregistered"]["null"]="";
$table[$prefix."_users"]["dateregistered"]["Extra"]="";

//`dateactivated` datetime NOT NULL default '0000-00-00 00:00:00',"
$table[$prefix."_users"]["dateactivated"]["field"]="dateactivated";
$table[$prefix."_users"]["dateactivated"]["type"]="datetime";
$table[$prefix."_users"]["dateactivated"]["default"]="0000-00-00 00:00:00";
$table[$prefix."_users"]["dateactivated"]["null"]="";
$table[$prefix."_users"]["dateactivated"]["Extra"]="";

//`lastvisit` datetime NOT NULL default '0000-00-00 00:00:00'
$table[$prefix."_users"]["lastvisit"]["field"]="lastvisit";
$table[$prefix."_users"]["lastvisit"]["type"]="datetime";
$table[$prefix."_users"]["lastvisit"]["default"]="0000-00-00 00:00:00";
$table[$prefix."_users"]["lastvisit"]["null"]="";
$table[$prefix."_users"]["lastvisit"]["Extra"]="";

//`logins` int(10) unsigned NOT NULL default '0'
$table[$prefix."_users"]["logins"]["field"]="logins";
$table[$prefix."_users"]["logins"]["type"]="int(10) unsigned";
$table[$prefix."_users"]["logins"]["default"]="0";
$table[$prefix."_users"]["logins"]["null"]="";
$table[$prefix."_users"]["logins"]["Extra"]="";

//`newemail` varchar(50) default NULL
$table[$prefix."_users"]["newemail"]["field"]="newemail";
$table[$prefix."_users"]["newemail"]["type"]="varchar(50)";
$table[$prefix."_users"]["newemail"]["default"]="";
$table[$prefix."_users"]["newemail"]["null"]="YES";
$table[$prefix."_users"]["newemail"]["Extra"]="";

//`newemailsess` varchar(32) default NULL
$table[$prefix."_users"]["newemailsess"]["field"]="newemailsess";
$table[$prefix."_users"]["newemailsess"]["type"]="varchar(32)";
$table[$prefix."_users"]["newemailsess"]["default"]="";
$table[$prefix."_users"]["newemailsess"]["null"]="YES";
$table[$prefix."_users"]["newemailsess"]["Extra"]="";

//`avatar` varchar(20) default NULL,"
$table[$prefix."_users"]["avatar"]["field"]="avatar";
$table[$prefix."_users"]["avatar"]["type"]="varchar(20)";
$table[$prefix."_users"]["avatar"]["default"]="";
$table[$prefix."_users"]["avatar"]["null"]="YES";
$table[$prefix."_users"]["avatar"]["Extra"]="";

//`signature` text NOT NULL
$table[$prefix."_users"]["signature"]["field"]="signature";
$table[$prefix."_users"]["signature"]["type"]="text";
$table[$prefix."_users"]["signature"]["default"]="";
$table[$prefix."_users"]["signature"]["null"]="";
$table[$prefix."_users"]["signature"]["Extra"]="";

//`lang` varchar(4) NOT NULL default '',"
$table[$prefix."_users"]["lang"]["field"]="lang";
$table[$prefix."_users"]["lang"]["type"]="varchar(4)";
$table[$prefix."_users"]["lang"]["default"]="";
$table[$prefix."_users"]["lang"]["null"]="";
$table[$prefix."_users"]["lang"]["Extra"]="";

//`theme` varchar(20) NOT NULL default '',"
$table[$prefix."_users"]["theme"]["field"]="theme";
$table[$prefix."_users"]["theme"]["type"]="varchar(20)";
$table[$prefix."_users"]["theme"]["default"]="";
$table[$prefix."_users"]["theme"]["null"]="";
$table[$prefix."_users"]["theme"]["Extra"]="";

//`banned` enum('N','Y') NOT NULL default 'N',"
$table[$prefix."_users"]["banned"]["field"]="banned";
$table[$prefix."_users"]["banned"]["type"]="enum('N','Y')";
$table[$prefix."_users"]["banned"]["default"]="N";
$table[$prefix."_users"]["banned"]["null"]="";
$table[$prefix."_users"]["banned"]["Extra"]="";

//`showemail` enum('N','Y') NOT NULL default 'N',"
$table[$prefix."_users"]["showemail"]["field"]="showemail";
$table[$prefix."_users"]["showemail"]["type"]="enum('N','Y')";
$table[$prefix."_users"]["showemail"]["default"]="N";
$table[$prefix."_users"]["showemail"]["null"]="";
$table[$prefix."_users"]["showemail"]["Extra"]="";

?>
